﻿using Syncfusion.Windows.Forms.Diagram;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication10
{
    public partial class Form1 : Form
    {
        Node Sel_Node;
        bool b = false;
        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {

            this.diagram2.DefaultContextMenuEnabled = false;

            Syncfusion.Windows.Forms.Diagram.Rectangle rect = new Syncfusion.Windows.Forms.Diagram.Rectangle(10, 10, 100, 100);
            diagram2.Model.AppendChild(rect);
            diagram2.MouseClick+=diagram2_MouseClick;
            diagram2.MouseMove += diagram2_MouseMove;
            

        }

        void diagram2_MouseMove(object sender, MouseEventArgs e)
        {
            PointF pts = diagram2.Controller.ConvertToModelCoordinates(new PointF(e.X, e.Y));
            Node nd = diagram2.Controller.GetNodeAtPoint(pts);
            if (nd != null)
            {
                b = true;
            }
            else
            {
                b = false;
                diagram2.ContextMenu = null;
            }
        }
        void diagram2_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Right && b)
            {
                PointF pts = diagram2.Controller.ConvertToModelCoordinates(new PointF(e.X, e.Y));
                Node nd = diagram2.Controller.GetNodeAtPoint(pts);
                if (nd != null)
                {

                    if (nd is Node)
                    {
                        System.Windows.Forms.ContextMenu cvp = new System.Windows.Forms.ContextMenu();
                        cvp.MenuItems.Add("Clone the Node");
                        cvp.MenuItems[0].Click += Form1_Click;
                        diagram2.ContextMenu = cvp;
                    }
                    
                }
            }
        }

        void Form1_Click(object sender, EventArgs e)
        {
            diagram2.Controller.Copy();
            ClipboardNodeCollection c = (ClipboardNodeCollection)clipboardData.GetData(typeof(ClipboardNodeCollection));
            NodeCollection nodes = c as NodeCollection;
            foreach (Node n in nodes)
            {
                Sel_Node = n;
                Sel_Node.PinPoint = new Point(100, 100);
                diagram2.Model.AppendChild(Sel_Node);
            }

        }

        
        
    }
}
